/*
 * Copyright (C) 2011-2021 Intel Corporation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 *   * Neither the name of Intel Corporation nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

//#include "Enclave.h"
#include "Enclave_t.h" /* print_string */
#include <stdarg.h>
#include <stdio.h> /* vsnprintf */
#include <string.h>
//#include "sgx_trts.h"
//#include "sgx_thread.h"
//#include "sgx_tseal.h"

#define PAGE_SIZE 4096
#define CACHE_LINE 64

#define READ(p)\
asm volatile ("movq %%rax, (%0)\n"\
    :\
    : "c" (p)\
    : "rax")\

//uint8_t array[ARRAY_SIZE];
uint8_t confidential[CACHE_LINE] = {0};
//confidential[0] = 32;
/* 
 * printf: 
 *   Invokes OCALL to display the enclave buffer to the terminal.
 */
/*
int printf(const char* fmt, ...)
{
    char buf[BUFSIZ] = { '\0' };
    va_list ap;
    va_start(ap, fmt);
    vsnprintf(buf, BUFSIZ, fmt, ap);
    va_end(ap);
    ocall_print_string(buf);
    return (int)strnlen(buf, BUFSIZ - 1) + 1;
}
*/

void initial_value() {
   confidential[0] = 42;
}

void ecall_gadget_function(uint8_t size, uint8_t *probe, uint8_t *array_size) {
   
   uint8_t array[size * CACHE_LINE];
   for (int i = 0; i < size; i++)
	   array[i * CACHE_LINE] = 0;
   //confidential[0] = 32;
   initial_value();
   uint64_t index = (uint64_t)(&confidential[0]) - (uint64_t)((uintptr_t)&array[0 * CACHE_LINE]);
   uint64_t idx = 0;
   uint8_t i = 0;
   for (i = 0; i < array_size[i * 4096];) {
	READ(&probe[(*(uint8_t*)(&array[0] + idx)) * PAGE_SIZE]);
        //value = (uint8_t *)(&array[0] + idx); 
        i+=1;
        //printf("%d\n", i);
        idx = (((size)^ i) - 1) & index;
   }
}
